:- module test_influence_map.
:- interface.
:- import_module io.

:- pred main(io__state::di, io__state::uo) is det.

%-----------------------------------------------------------------------------%

:- implementation.
:- import_module game, protocol, list, debug, influence_map.

main -->
	io__print("init:\n"),
	io__flush_output,
	init(Game),
	{ Board = Game^board },
	io__print("board:\n"),
	io__flush_output,
	print("Width = "), print(width(Board)),
	print(", height = "), print(height(Board)), nl,
	%output_board(Board, output_square(Game)),
	io__report_stats,
	io__nl, io__nl,

	io__print("base distance map:\n"),
	io__flush_output,
	{ BaseDistanceIM = compute_base_distance_im(Board) },
	print("Width = "), print(width(BaseDistanceIM)),
	print(", height = "), print(height(BaseDistanceIM)), nl,
	%output_board(BaseDistanceIM, output_distance),
	io__report_stats,
	io__nl, io__nl,

	io__print("enemy distance map:\n"),
	io__flush_output,
	{ EnemyDistanceIM = compute_enemy_distance_im(Game) },
	print("Width = "), print(width(EnemyDistanceIM)),
	print(", height = "), print(height(EnemyDistanceIM)), nl,
	%output_board(EnemyDistanceIM, output_distance),
	io__report_stats,
	io__nl, io__nl,

	io__print("done.\n").

init(Game) -->
	send_init,
	read_board(Board),
	read_config(Config),
	read_server_response(InitialResponse),
	{ Game = init_game(Board, Config, InitialResponse) },
	io__stderr_stream(Stderr),
	io__write_string(Stderr, "finished init\n").

%-----------------------------------------------------------------------------%
